#include <u.h>
#include <libc.h>
#include <auth.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>

enum { QSIZE = 10 };

typedef struct Queue Queue;
typedef struct Reader Reader;
typedef struct Message Message;

struct Message
{
	Ref;
	int len;
	/* char data[len]; */
};

struct Queue
{
	Message *data[QSIZE];
	int wr;
	Reader *rd;
};

struct Reader
{
	Reader *next;
	Queue *q;
	int pos;
	int offset;	// inside current message
	Req *rq;
};

Reader *newreader(Queue *q);
void removereader(Queue *q, Reader *r);
Message *peekmsg(Reader *r);
Message *getmsg(Reader *r);
void addmsg(Queue *q, char *data, int len);
Message *releasemsg(Message *m);
